/* tp_flags */
#define TPF_FIXED	1	/* i.e., broken--must use 'fixed' mode */
#define TPF_ASPI	128	/* ASPI device */
/* tp_state */
#define TPS_BUF 	1	/* currently open as buffered device */
#define TPS_RAW 	2	/* currently open as nonbuffered device */
#define TPS_REW		4	/* rewind on last close */
#define TPS_WRIT	8	/* tape written on */
#define TPS_READ	16	/* tape read from */
#define TPS_ZERO	32	/* next read will return 0 bytes */
#define TPS_IEOT	64	/* map end-of-medium to end-of-file */
#define TPS_WIND	128	/* device may be busy rewinding */

/* packed SCSI commands */
#define op(x,y,z) ((x)|((y)<<8)|((z)<<8))
#define IFLG 8	/* ASPI direction in */
#define OFLG 16	/* ASPI direction out */

#define TEST_UNIT_RDY	op(0,0,0)
#define REWIND_WAIT	op(1,0,0)	/* rewind tape, wait for completion */
#define REWIND_NOWAIT	op(1,1,0)	/* rewind, immediate return */
#define REQUEST_SENSE	op(3,0,IFLG)
#define READ_BLK_LMTS	op(5,0,IFLG)	/* read block limits */
#define READ_VAR	op(8,0,IFLG)	/* read bytes */
#define READ_FIXED	op(8,1,IFLG)	/* read blocks */
#define READ_VAR_OK	op(8,2,IFLG)	/* suppress illegal length errors */
#define WRITE_VAR	op(10,0,OFLG)	/* write bytes */
#define WRITE_FIXED	op(10,1,OFLG)	/* write blocks */
#define WRITE_FILEMARK	op(16,0,0)	/* write long filemark only */
#define SPACE_RECORDS	op(17,0,0)	/* space back/forth records */
#define SPACE_FILES	op(17,1,0)	/* space back/forth files */
#define INQUIRY		op(18,0,IFLG)
#define MODE_SELECT	op(21,0,OFLG)
#define ERASE		op(25,1,0)	/* erase to PEOT */
#define MODE_SENSE	op(26,0,IFLG)
#define LOAD_WAIT	op(27,0,0)	/* load/unload & wait until done */
#define LOAD_NOWAIT	op(27,1,0)	/* load/unload and return at once */
#define MEDIA_REMOVE	op(30,0,0)	/* prevent/allow media removal */

/* fake transfer length parameters for various commands */
#define UNLOAD	0	/* for LOAD_WAIT/LOAD_NOWAIT commands */
#define LOAD	1	/* for LOAD_WAIT/LOAD_NOWAIT commands */
#define ALLOW	0	/* for MEDIA_REMOVE command */
#define PREVENT	1	/* for MEDIA_REMOVE command */
